# WARNING - Generated by {fusen} from /dev/flat_globallandcover.Rmd: do not edit by hand

#' Download Landcover tiles
#'
#' @param aoi sf object EPSG:4326
#' @param download_directory download directory
#'
#' @return nothing
#' @importFrom dplyr filter
#' @importFrom sf st_intersects
#' @importFrom cli cli_progress_bar
#' @importFrom httr GET write_disk timeout
#' @export
#'
#' @examples
#' \dontrun{
#' library(nominatimlite)
#' aoi <- geo_lite_sf("Mondulkiri", points_only = FALSE) %>%
#'   st_transform(crs=4326)
#' 
#' downloadLandcover(aoi = aoi, index=getTilesIndex(), download_directory = tempdir())
#' }
downloadLandcover <- function(aoi, download_directory){
  spatialSubset <- subset(index, st_intersects(geometry, aoi, sparse = FALSE))
  cli_progress_bar("Download tiles", total = nrow(spatialSubset))
  for(i in 1:nrow(spatialSubset)){
    cli_progress_update()
    GET(url = paste0("http://data.ess.tsinghua.edu.cn/data/fromglc10_2017v01/", spatialSubset[i,]$filename),
        write_disk(paste(download_directory, spatialSubset[i,]$filename), overwrite = TRUE) ,
        timeout(300L),
        quiet = TRUE)
  }
  cli_progress_done()
}
